/* -*- Mode: c; c-basic-offset: 8; Coding: utf-8-unix -*- ;; */
/* $Id: ini.h 2 2008-05-27 07:44:27Z mtaneda $	 */

/*
 * Copyright 2008 The piranha Project. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PIRANHA PROJECT ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
 * EVENT SHALL THE PIRANHA PROJECT OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation are
 * those of the authors and should not be interpreted as representing official
 * policies, either expressed or implied, of the piranha Project.
 */

#ifndef	_inc_ini_h
#define	_inc_ini_h

#include	"pairlist.h"

typedef struct ini ini_t;

extern ini_t   *
                ini_load(const char *file, const char *eol, const char *delim, const char comment);
extern int
                ini_unload(ini_t * obj);
extern int
                ini_save(const ini_t * ini, const char *file, const char *eol, const char *delim);

extern int
                ini_add_section(ini_t * ini, const char *name);
extern int
                ini_is_exist_section(const ini_t * ini, const char *name);

extern int
                ini_add_data(ini_t * ini, const char *section, const char *name, const char *value);

extern pairlist_t *
                ini_refer_data_by_section(const ini_t * ini, const char *section);
extern pairlist_t *
                ini_get_data_by_section(const ini_t * ini, const char *section);

extern char    *
                ini_refer_value_by_name(const ini_t * ini, const char *section, const char *name);
extern char    *
                ini_get_value_by_name(const ini_t * ini, const char *section, const char *name);

#endif
